Add ability to parse more kinds of test results
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2023 Cisco and/or its affiliates.
2 # Copyright (c) 2023 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     parse_env_variables || die "Parse of environment variables failed!"
83
84     # Replace all variables in template with those in environment.
85     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
86         die "Topology file create failed!"
87     }
88
89     WORKING_TOPOLOGY="${CSIT_DIR}/topologies/available/vpp_device.yaml"
90     mv topo.yml "${WORKING_TOPOLOGY}" || {
91         die "Topology move failed!"
92     }
93     cat ${WORKING_TOPOLOGY} | grep -v password || {
94         die "Topology read failed!"
95     }
96 }
97
98
99 function activate_virtualenv () {
100
101     # Update virtualenv pip package, delete and create virtualenv directory,
102     # activate the virtualenv, install requirements, set PYTHONPATH.
103
104     # Arguments:
105     # - ${1} - Path to existing directory for creating virtualenv in.
106     #          If missing or empty, ${CSIT_DIR} is used.
107     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
108     # Variables read:
109     # - CSIT_DIR - Path to existing root of local CSIT git repository.
110     # Variables exported:
111     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
112     # Functions called:
113     # - die - Print to stderr and exit.
114
115     set -exuo pipefail
116
117     root_path="${1-$CSIT_DIR}"
118     env_dir="${root_path}/env"
119     req_path=${2-$CSIT_DIR/requirements.txt}
120     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
121     pip3 install virtualenv==20.15.1 || {
122         die "Virtualenv package install failed."
123     }
124     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
125         die "Virtualenv creation for $(which python3) failed."
126     }
127     set +u
128     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
129     set -u
130     pip3 install -r "${req_path}" || {
131         die "Requirements installation failed."
132     }
133     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
134     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
135 }
136
137
138 function archive_tests () {
139
140     # Create .tar.gz of generated/tests for archiving.
141     # To be run after generate_tests, kept separate to offer more flexibility.
142
143     # Directory read:
144     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
145     # File rewriten:
146     # - ${ARCHIVE_DIR}/generated_tests.tar.gz - Archive of generated tests.
147
148     set -exuo pipefail
149
150     pushd "${ARCHIVE_DIR}" || die
151     tar czf "generated_tests.tar.gz" "${GENERATED_DIR}/tests" || true
152     popd || die
153 }
154
155
156 function check_download_dir () {
157
158     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
159     #
160     # Variables read:
161     # - DOWNLOAD_DIR - Path to directory robot takes the build to test from.
162     # Directories read:
163     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
164     # Functions called:
165     # - die - Print to stderr and exit.
166
167     set -exuo pipefail
168
169     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
170         die "No artifacts downloaded!"
171     fi
172 }
173
174
175 function check_prerequisites () {
176
177     # Fail if prerequisites are not met.
178     #
179     # Functions called:
180     # - installed - Check if application is installed/present in system.
181     # - die - Print to stderr and exit.
182
183     set -exuo pipefail
184
185     if ! installed sshpass; then
186         die "Please install sshpass before continue!"
187     fi
188 }
189
190
191 function common_dirs () {
192
193     # Set global variables, create some directories (without touching content).
194
195     # Variables set:
196     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
197     # - CSIT_DIR - Path to existing root of local CSIT git repository.
198     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
199     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
200     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
201     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
202     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
203     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
204     #   The name is chosen to match what ci-management expects.
205     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
206     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
207     # Directories created if not present:
208     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
209     # Functions called:
210     # - die - Print to stderr and exit.
211
212     set -exuo pipefail
213
214     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
215         die "Some error during locating of this source file."
216     }
217     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
218         die "Some error during dirname call."
219     }
220     # Current working directory could be in a different repo, e.g. VPP.
221     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
222     relative_csit_dir=$(git rev-parse --show-toplevel) || {
223         die "Git rev-parse failed."
224     }
225     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
226     popd || die "Popd failed."
227     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
228         die "Readlink failed."
229     }
230     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/resources/job_specs") || {
231         die "Readlink failed."
232     }
233     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
234         die "Readlink failed."
235     }
236     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
237         die "Readlink failed."
238     }
239     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
240         die "Readlink failed."
241     }
242
243     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
247     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
251     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
252         die "Readlink failed."
253     }
254     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
255 }
256
257
258 function compose_robot_arguments () {
259
260     # Variables read:
261     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
262     # - DUT - CSIT test/ subdirectory, set while processing tags.
263     # - TAGS - Array variable holding selected tag boolean expressions.
264     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
265     # - TEST_CODE - The test selection string from environment or argument.
266     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
267     # Variables set:
268     # - ROBOT_ARGS - String holding part of all arguments for robot.
269     # - EXPANDED_TAGS - Array of strings robot arguments compiled from tags.
270
271     set -exuo pipefail
272
273     # No explicit check needed with "set -u".
274     ROBOT_ARGS=("--loglevel" "TRACE")
275     ROBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
276
277     case "${TEST_CODE}" in
278         *"device"*)
279             ROBOT_ARGS+=("--suite" "tests.${DUT}.device")
280             ;;
281         *"perf"*)
282             ROBOT_ARGS+=("--suite" "tests.${DUT}.perf")
283             ;;
284         *)
285             die "Unknown specification: ${TEST_CODE}"
286     esac
287
288     EXPANDED_TAGS=()
289     for tag in "${TAGS[@]}"; do
290         if [[ ${tag} == "!"* ]]; then
291             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
292         else
293             if [[ ${SELECTION_MODE} == "--test" ]]; then
294                 EXPANDED_TAGS+=("--test" "${tag}")
295             else
296                 EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
297             fi
298         fi
299     done
300
301     if [[ ${SELECTION_MODE} == "--test" ]]; then
302         EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
303     fi
304 }
305
306
307 function deactivate_docker_topology () {
308
309     # Deactivate virtual vpp-device topology by removing containers.
310     #
311     # Variables read:
312     # - NODENESS - Node multiplicity of desired testbed.
313     # - FLAVOR - Node flavor string, usually describing the processor.
314
315     set -exuo pipefail
316
317     case_text="${NODENESS}_${FLAVOR}"
318     case "${case_text}" in
319         "1n_skx" | "1n_tx2")
320             ssh="ssh root@172.17.0.1 -p 6022"
321             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
322             # The "declare -f" output is long and boring.
323             set +x
324             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
325                 die "Topology cleanup via shim-dcr failed!"
326             }
327             set -x
328             ;;
329         "1n_vbox")
330             enter_mutex || die
331             clean_environment || {
332                 die "Topology cleanup locally failed!"
333             }
334             exit_mutex || die
335             ;;
336         *)
337             die "Unknown specification: ${case_text}!"
338     esac
339 }
340
341
342 function die () {
343
344     # Print the message to standard error end exit with error code specified
345     # by the second argument.
346     #
347     # Hardcoded values:
348     # - The default error message.
349     # Arguments:
350     # - ${1} - The whole error message, be sure to quote. Optional
351     # - ${2} - the code to exit with, default: 1.
352
353     set -x
354     set +eu
355     warn "${1:-Unspecified run-time error occurred!}"
356     exit "${2:-1}"
357 }
358
359
360 function die_on_robot_error () {
361
362     # Source this fragment if you want to abort on any failed test case.
363     #
364     # Variables read:
365     # - ROBOT_EXIT_STATUS - Set by a robot running fragment.
366     # Functions called:
367     # - die - Print to stderr and exit.
368
369     set -exuo pipefail
370
371     if [[ "${ROBOT_EXIT_STATUS}" != "0" ]]; then
372         die "Test failures are present!" "${ROBOT_EXIT_STATUS}"
373     fi
374 }
375
376
377 function generate_tests () {
378
379     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
380     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
381     # The generation is done by executing any *.py executable
382     # within any subdirectory after copying.
383
384     # This is a separate function, because this code is called
385     # both by autogen checker and entries calling run_robot.
386
387     # Directories read:
388     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
389     # Directories replaced:
390     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
391
392     set -exuo pipefail
393
394     rm -rf "${GENERATED_DIR}/tests" || die
395     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
396     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
397     cmd_line+=("-executable" "-name" "*.py")
398     # We sort the directories, so log output can be compared between runs.
399     file_list=$("${cmd_line[@]}" | sort) || die
400
401     for gen in ${file_list}; do
402         directory="$(dirname "${gen}")" || die
403         filename="$(basename "${gen}")" || die
404         pushd "${directory}" || die
405         ./"${filename}" || die
406         popd || die
407     done
408 }
409
410
411 function get_test_code () {
412
413     # Arguments:
414     # - ${1} - Optional, argument of entry script (or empty as unset).
415     #   Test code value to override job name from environment.
416     # Variables read:
417     # - JOB_NAME - String affecting test selection, default if not argument.
418     # Variables set:
419     # - TEST_CODE - The test selection string from environment or argument.
420     # - NODENESS - Node multiplicity of desired testbed.
421     # - FLAVOR - Node flavor string, usually describing the processor.
422
423     set -exuo pipefail
424
425     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
426     if [[ -z "${TEST_CODE}" ]]; then
427         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
428     fi
429
430     case "${TEST_CODE}" in
431         *"1n-vbox"*)
432             NODENESS="1n"
433             FLAVOR="vbox"
434             ;;
435         *"1n-skx"*)
436             NODENESS="1n"
437             FLAVOR="skx"
438             ;;
439         *"1n-tx2"*)
440             NODENESS="1n"
441             FLAVOR="tx2"
442             ;;
443         *"1n-aws"*)
444             NODENESS="1n"
445             FLAVOR="aws"
446             ;;
447         *"2n-aws"*)
448             NODENESS="2n"
449             FLAVOR="aws"
450             ;;
451         *"3n-aws"*)
452             NODENESS="3n"
453             FLAVOR="aws"
454             ;;
455         *"1n-c6gn"*)
456             NODENESS="1n"
457             FLAVOR="c6gn"
458             ;;
459         *"2n-c6gn"*)
460             NODENESS="2n"
461             FLAVOR="c6gn"
462             ;;
463         *"3n-c6gn"*)
464             NODENESS="3n"
465             FLAVOR="c6gn"
466             ;;
467         *"1n-c6in"*)
468             NODENESS="1n"
469             FLAVOR="c6in"
470             ;;
471         *"2n-c6in"*)
472             NODENESS="2n"
473             FLAVOR="c6in"
474             ;;
475         *"3n-c6in"*)
476             NODENESS="3n"
477             FLAVOR="c6in"
478             ;;
479         *"2n-zn2"*)
480             NODENESS="2n"
481             FLAVOR="zn2"
482             ;;
483         *"2n-clx"*)
484             NODENESS="2n"
485             FLAVOR="clx"
486             ;;
487         *"2n-icx"*)
488             NODENESS="2n"
489             FLAVOR="icx"
490             ;;
491         *"2n-spr"*)
492             NODENESS="2n"
493             FLAVOR="spr"
494             ;;
495         *"3n-icx"*)
496             NODENESS="3n"
497             FLAVOR="icx"
498             ;;
499         *"3na-spr"*)
500             NODENESS="3na"
501             FLAVOR="spr"
502             ;;
503         *"3nb-spr"*)
504             NODENESS="3nb"
505             FLAVOR="spr"
506             ;;
507         *"3n-snr"*)
508             NODENESS="3n"
509             FLAVOR="snr"
510             ;;
511         *"2n-tx2"*)
512             NODENESS="2n"
513             FLAVOR="tx2"
514             ;;
515         *"3n-tsh"*)
516             NODENESS="3n"
517             FLAVOR="tsh"
518             ;;
519         *"3n-alt"*)
520             NODENESS="3n"
521             FLAVOR="alt"
522             ;;
523     esac
524 }
525
526
527 function get_test_tag_string () {
528
529     # Variables read:
530     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
531     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
532     # - TEST_CODE - The test selection string from environment or argument.
533     # Variables set:
534     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
535     #   May be empty, or even not set on event types not adding comment.
536     # Variables exported optionally:
537     # - GRAPH_NODE_VARIANT - Node variant to test with, set if found in trigger.
538
539     # TODO: ci-management scripts no longer need to perform this.
540
541     set -exuo pipefail
542
543     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
544         case "${TEST_CODE}" in
545             *"device"*)
546                 trigger="devicetest"
547                 ;;
548             *"perf"*)
549                 trigger="perftest"
550                 ;;
551             *)
552                 die "Unknown specification: ${TEST_CODE}"
553         esac
554         # Ignore lines not containing the trigger word.
555         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
556         # The vpp-csit triggers trail stuff we are not interested in.
557         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
558         # (except relying on \s whitespace, \S non-whitespace and . both).
559         # The last string is concatenated, only the middle part is expanded.
560         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
561         # On parsing error, TEST_TAG_STRING probably stays empty.
562         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
563         if [[ -z "${TEST_TAG_STRING-}" ]]; then
564             # Probably we got a base64 encoded comment.
565             comment="${GERRIT_EVENT_COMMENT_TEXT}"
566             comment=$(base64 --decode <<< "${comment}" || true)
567             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
568             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
569         fi
570         if [[ -n "${TEST_TAG_STRING-}" ]]; then
571             test_tag_array=(${TEST_TAG_STRING})
572             if [[ "${test_tag_array[0]}" == "icl" ]]; then
573                 export GRAPH_NODE_VARIANT="icl"
574                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
575             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
576                 export GRAPH_NODE_VARIANT="skx"
577                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
578             fi
579         fi
580     fi
581 }
582
583
584 function installed () {
585
586     # Check if the given utility is installed. Fail if not installed.
587     #
588     # Duplicate of common.sh function, as this file is also used standalone.
589     #
590     # Arguments:
591     # - ${1} - Utility to check.
592     # Returns:
593     # - 0 - If command is installed.
594     # - 1 - If command is not installed.
595
596     set -exuo pipefail
597
598     command -v "${1}"
599 }
600
601
602 function move_archives () {
603
604     # Move archive directory to top of workspace, if not already there.
605     #
606     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
607     # but in some jobs CSIT_DIR is not same as WORKSPACE
608     # (e.g. under VPP_DIR). To simplify ci-management settings,
609     # we want to move the data to the top. We do not want simple copy,
610     # as ci-management is eager with recursive search.
611     #
612     # As some scripts may call this function multiple times,
613     # the actual implementation use copying and deletion,
614     # so the workspace gets "union" of contents (except overwrites on conflict).
615     # The consequence is empty ARCHIVE_DIR remaining after this call.
616     #
617     # As the source directory is emptied,
618     # the check for dirs being different is essential.
619     #
620     # Variables read:
621     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
622     #   Can be unset, then it speeds up manual testing.
623     # - ARCHIVE_DIR - Path to directory with content to be moved.
624     # Directories updated:
625     # - ${WORKSPACE}/archives/ - Created if does not exist.
626     #   Content of ${ARCHIVE_DIR}/ is moved.
627     # Functions called:
628     # - die - Print to stderr and exit.
629
630     set -exuo pipefail
631
632     if [[ -n "${WORKSPACE-}" ]]; then
633         target=$(readlink -f "${WORKSPACE}/archives")
634         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
635             mkdir -p "${target}" || die "Archives dir create failed."
636             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
637             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
638         fi
639     fi
640 }
641
642
643 function prepare_topology () {
644
645     # Prepare virtual testbed topology if needed based on flavor.
646
647     # Variables read:
648     # - TEST_CODE - String affecting test selection, usually jenkins job name.
649     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
650     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
651     # Variables set:
652     # - TERRAFORM_MODULE_DIR - Terraform module directory.
653     # Functions called:
654     # - die - Print to stderr and exit.
655     # - terraform_init - Terraform init topology.
656     # - terraform_apply - Terraform apply topology.
657
658     set -exuo pipefail
659
660     case_text="${NODENESS}_${FLAVOR}"
661     case "${case_text}" in
662         "1n_aws" | "2n_aws" | "3n_aws")
663             export TF_VAR_testbed_name="${TEST_CODE}"
664             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
665             terraform_init || die "Failed to call terraform init."
666             trap "terraform_destroy" ERR EXIT || {
667                 die "Trap attempt failed, please cleanup manually. Aborting!"
668             }
669             terraform_apply || die "Failed to call terraform apply."
670             ;;
671         "1n_c6gn" | "2n_c6gn" | "3n_c6gn")
672             export TF_VAR_testbed_name="${TEST_CODE}"
673             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-c6gn"
674             terraform_init || die "Failed to call terraform init."
675             trap "terraform_destroy" ERR EXIT || {
676                 die "Trap attempt failed, please cleanup manually. Aborting!"
677             }
678             terraform_apply || die "Failed to call terraform apply."
679             ;;
680         "1n_c6in" | "2n_c6in" | "3n_c6in")
681             export TF_VAR_testbed_name="${TEST_CODE}"
682             TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-c6in"
683             terraform_init || die "Failed to call terraform init."
684             trap "terraform_destroy" ERR EXIT || {
685                 die "Trap attempt failed, please cleanup manually. Aborting!"
686             }
687             terraform_apply || die "Failed to call terraform apply."
688             ;;
689     esac
690 }
691
692
693 function reserve_and_cleanup_testbed () {
694
695     # Reserve physical testbed, perform cleanup, register trap to unreserve.
696     # When cleanup fails, remove from topologies and keep retrying
697     # until all topologies are removed.
698     #
699     # Variables read:
700     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
701     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
702     # - BUILD_TAG - Any string suitable as filename, identifying
703     #   test run executing this function. May be unset.
704     # Variables set:
705     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
706     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
707     # Functions called:
708     # - die - Print to stderr and exit.
709     # - ansible_playbook - Perform an action using ansible, see ansible.sh
710     # Traps registered:
711     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
712
713     set -exuo pipefail
714
715     while true; do
716         for topo in "${TOPOLOGIES[@]}"; do
717             set +e
718             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
719             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
720             python3 "${scrpt}" "${opts[@]}"
721             result="$?"
722             set -e
723             if [[ "${result}" == "0" ]]; then
724                 # Trap unreservation before cleanup check,
725                 # so multiple jobs showing failed cleanup improve chances
726                 # of humans to notice and fix.
727                 WORKING_TOPOLOGY="${topo}"
728                 echo "Reserved: ${WORKING_TOPOLOGY}"
729                 trap "untrap_and_unreserve_testbed" EXIT || {
730                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
731                     untrap_and_unreserve_testbed "${message}" || {
732                         die "Teardown should have died, not failed."
733                     }
734                     die "Trap attempt failed, unreserve succeeded. Aborting."
735                 }
736                 # Cleanup + calibration checks
737                 set +e
738                 ansible_playbook "cleanup, calibration"
739                 result="$?"
740                 set -e
741                 if [[ "${result}" == "0" ]]; then
742                     break
743                 fi
744                 warn "Testbed cleanup failed: ${topo}"
745                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
746             fi
747             # Else testbed is accessible but currently reserved, moving on.
748         done
749
750         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
751             # Exit the infinite while loop if we made a reservation.
752             warn "Reservation and cleanup successful."
753             break
754         fi
755
756         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
757             die "Run out of operational testbeds!"
758         fi
759
760         # Wait ~3minutes before next try.
761         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
762             die "Sleep time calculation failed."
763         }
764         echo "Sleeping ${sleep_time}"
765         sleep "${sleep_time}" || die "Sleep failed."
766     done
767 }
768
769
770 function run_robot () {
771
772     # Run robot with options based on input variables.
773     #
774     # Variables read:
775     # - CSIT_DIR - Path to existing root of local CSIT git repository.
776     # - ARCHIVE_DIR - Path to store robot result files in.
777     # - ROBOT_ARGS, EXPANDED_TAGS - See compose_robot_arguments.sh
778     # - GENERATED_DIR - Tests are assumed to be generated under there.
779     # Variables set:
780     # - ROBOT_EXIT_STATUS - Exit status of most recent robot invocation.
781     # Functions called:
782     # - die - Print to stderr and exit.
783
784     set -exuo pipefail
785
786     all_options=("--outputdir" "${ARCHIVE_DIR}" "${ROBOT_ARGS[@]}")
787     all_options+=("${EXPANDED_TAGS[@]}")
788
789     pushd "${CSIT_DIR}" || die "Change directory operation failed."
790     set +e
791     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
792     ROBOT_EXIT_STATUS="$?"
793     set -e
794
795     popd || die "Change directory operation failed."
796 }
797
798
799 function select_arch_os () {
800
801     # Set variables affected by local CPU architecture and operating system.
802     #
803     # Variables set:
804     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
805     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
806     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
807
808     set -exuo pipefail
809
810     source /etc/os-release || die "Get OS release failed."
811
812     case "${ID}" in
813         "ubuntu"*)
814             case "${VERSION}" in
815                 *"LTS (Jammy Jellyfish)"*)
816                     IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU_JAMMY"
817                     VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_JAMMY"
818                     PKG_SUFFIX="deb"
819                     ;;
820                 *)
821                     die "Unsupported Ubuntu version!"
822                     ;;
823             esac
824             ;;
825         *)
826             die "Unsupported distro or OS!"
827             ;;
828     esac
829
830     arch=$(uname -m) || {
831         die "Get CPU architecture failed."
832     }
833
834     case "${arch}" in
835         "aarch64")
836             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
837             ;;
838         *)
839             ;;
840     esac
841 }
842
843
844 function select_tags () {
845
846     # Variables read:
847     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
848     # - TEST_CODE - String affecting test selection, usually jenkins job name.
849     # - DUT - CSIT test/ subdirectory, set while processing tags.
850     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
851     #   Can be unset.
852     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
853     # - BASH_FUNCTION_DIR - Directory with input files to process.
854     # Variables set:
855     # - TAGS - Array of processed tag boolean expressions.
856     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
857
858     set -exuo pipefail
859
860     # NIC SELECTION
861     case "${TEST_CODE}" in
862         *"1n-aws"* | *"1n-c6gn"* | *"1n-c6in"*)
863             start_pattern='^  SUT:'
864             ;;
865         *)
866             start_pattern='^  TG:'
867             ;;
868     esac
869     end_pattern='^ \? \?[A-Za-z0-9]\+:'
870     # Remove the sections from topology file
871     sed_command="/${start_pattern}/,/${end_pattern}/d"
872     # All topologies NICs
873     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
874                 | grep -hoP "model: \K.*" | sort -u)
875     # Selected topology NICs
876     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
877                | grep -hoP "model: \K.*" | sort -u)
878     # All topologies NICs - Selected topology NICs
879     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
880         die "Computation of excluded NICs failed."
881     }
882
883     # Select default NIC tag.
884     case "${TEST_CODE}" in
885         *"3n-snr"*)
886             default_nic="nic_intel-e822cq"
887             ;;
888         *"3n-tsh"*)
889             default_nic="nic_intel-x520-da2"
890             ;;
891         *"3n-icx"* | *"2n-icx"*)
892             default_nic="nic_intel-e810cq"
893             ;;
894         *"3na-spr"*)
895             default_nic="nic_mellanox-cx7veat"
896             ;;
897         *"3nb-spr"*)
898             default_nic="nic_intel-e810cq"
899             ;;
900         *"2n-spr"*)
901             default_nic="nic_intel-e810cq"
902             ;;
903         *"2n-clx"* | *"2n-zn2"*)
904             default_nic="nic_intel-xxv710"
905             ;;
906         *"2n-tx2"* | *"3n-alt"*)
907             default_nic="nic_intel-xl710"
908             ;;
909         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
910             default_nic="nic_amazon-nitro-50g"
911             ;;
912         *"1n-c6gn"* | *"2n-c6gn"* | *"3n-c6gn"*)
913             default_nic="nic_amazon-nitro-100g"
914             ;;
915         *"1n-c6in"* | *"2n-c6in"* | *"3n-c6in"*)
916             default_nic="nic_amazon-nitro-200g"
917             ;;
918         *)
919             default_nic="nic_intel-x710"
920             ;;
921     esac
922
923     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
924     awk_nics_sub_cmd=""
925     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
926     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
927     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
928     awk_nics_sub_cmd+='gsub("x520-da2","10ge2p1x520");'
929     awk_nics_sub_cmd+='gsub("cx556a","100ge2p1cx556a");'
930     awk_nics_sub_cmd+='gsub("cx7veat","200ge2p1cx7veat");'
931     awk_nics_sub_cmd+='gsub("cx6dx","100ge2p1cx6dx");'
932     awk_nics_sub_cmd+='gsub("e810cq","100ge2p1e810cq");'
933     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
934     awk_nics_sub_cmd+='gsub("vic1385","40ge2p1vic1385");'
935     awk_nics_sub_cmd+='gsub("nitro-50g","50ge1p1ENA");'
936     awk_nics_sub_cmd+='gsub("nitro-100g","100ge1p1ENA");'
937     awk_nics_sub_cmd+='gsub("nitro-200g","200ge1p1ENA");'
938     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
939     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
940     awk_nics_sub_cmd+='else if ($9 =="drv_mlx5_core") drv ="mlx5-";'
941     awk_nics_sub_cmd+='else if ($9 =="drv_af_xdp") drv ="af-xdp-";'
942     awk_nics_sub_cmd+='else drv="";'
943     awk_nics_sub_cmd+='if ($1 =="-") cores="";'
944     awk_nics_sub_cmd+='else cores=$1;'
945     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-" cores "-" drv $11"-"$5'
946
947     # Tag file directory shorthand.
948     tfd="${JOB_SPECS_DIR}"
949     case "${TEST_CODE}" in
950         # Select specific performance tests based on jenkins job type variable.
951         *"device"* )
952             readarray -t test_tag_array <<< $(grep -v "#" \
953                 ${tfd}/vpp_device/${DUT}-${NODENESS}-${FLAVOR}.md |
954                 awk {"$awk_nics_sub_cmd"} || echo "devicetest") || die
955             SELECTION_MODE="--test"
956             ;;
957         *"hoststack-daily"* )
958             readarray -t test_tag_array <<< $(grep -v "#" \
959                 ${tfd}/hoststack_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
960                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
961             SELECTION_MODE="--test"
962             ;;
963         *"ndrpdr-weekly"* )
964             readarray -t test_tag_array <<< $(grep -v "#" \
965                 ${tfd}/ndrpdr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
966                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
967             SELECTION_MODE="--test"
968             ;;
969         *"mrr-daily"* )
970             readarray -t test_tag_array <<< $(grep -v "#" \
971                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
972                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
973             SELECTION_MODE="--test"
974             ;;
975         *"mrr-weekly"* )
976             readarray -t test_tag_array <<< $(grep -v "#" \
977                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
978                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
979             SELECTION_MODE="--test"
980             ;;
981         *"report-iterative"* )
982             test_sets=(${TEST_TAG_STRING//:/ })
983             # Run only one test set per run
984             report_file=${test_sets[0]}.md
985             readarray -t test_tag_array <<< $(grep -v "#" \
986                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
987                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
988             SELECTION_MODE="--test"
989             ;;
990         *"report-coverage"* )
991             test_sets=(${TEST_TAG_STRING//:/ })
992             # Run only one test set per run
993             report_file=${test_sets[0]}.md
994             readarray -t test_tag_array <<< $(grep -v "#" \
995                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
996                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
997             SELECTION_MODE="--test"
998             ;;
999         * )
1000             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1001                 # If nothing is specified, we will run pre-selected tests by
1002                 # following tags.
1003                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDethip4-ip4base"
1004                                 "mrrAND${default_nic}AND1cAND78bANDethip6-ip6base"
1005                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2bdbasemaclrn"
1006                                 "mrrAND${default_nic}AND1cAND64bANDeth-l2xcbase"
1007                                 "!drv_af_xdp" "!drv_avf")
1008             else
1009                 # If trigger contains tags, split them into array.
1010                 test_tag_array=(${TEST_TAG_STRING//:/ })
1011             fi
1012             SELECTION_MODE="--include"
1013             ;;
1014     esac
1015
1016     # Blacklisting certain tags per topology.
1017     #
1018     # Reasons for blacklisting:
1019     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
1020     case "${TEST_CODE}" in
1021         *"1n-vbox"*)
1022             test_tag_array+=("!avf")
1023             test_tag_array+=("!vhost")
1024             test_tag_array+=("!flow")
1025             ;;
1026         *"1n_tx2"*)
1027             test_tag_array+=("!flow")
1028             ;;
1029         *"2n-clx"*)
1030             test_tag_array+=("!ipsechw")
1031             ;;
1032         *"2n-icx"*)
1033             test_tag_array+=("!ipsechw")
1034             ;;
1035         *"2n-spr"*)
1036             test_tag_array+=("!ipsechw")
1037             ;;
1038         *"2n-tx2"*)
1039             test_tag_array+=("!ipsechw")
1040             ;;
1041         *"2n-zn2"*)
1042             test_tag_array+=("!ipsechw")
1043             ;;
1044         *"3n-alt"*)
1045             test_tag_array+=("!ipsechw")
1046             ;;
1047         *"3n-icx"*)
1048             test_tag_array+=("!ipsechw")
1049             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
1050             ;;
1051         *"3n-snr"*)
1052             ;;
1053         *"3na-spr"*)
1054             test_tag_array+=("!ipsechw")
1055             ;;
1056         *"3nb-spr"*)
1057             test_tag_array+=("!ipsechw")
1058             ;;
1059         *"3n-tsh"*)
1060             test_tag_array+=("!drv_avf")
1061             test_tag_array+=("!ipsechw")
1062             ;;
1063         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1064             test_tag_array+=("!ipsechw")
1065             ;;
1066         *"1n-c6gn"* | *"2n-c6gn"* | *"3n-c6gn"*)
1067             test_tag_array+=("!ipsechw")
1068             ;;
1069         *"1n-c6in"* | *"2n-c6in"* | *"3n-c6in"*)
1070             test_tag_array+=("!ipsechw")
1071             ;;
1072     esac
1073
1074     # We will add excluded NICs.
1075     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
1076
1077     TAGS=()
1078     prefix=""
1079     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1080         if [[ "${TEST_CODE}" != *"device"* ]]; then
1081             # Automatic prefixing for VPP perf jobs to limit the NIC used.
1082             if [[ "${TEST_TAG_STRING-}" != *"nic_"* ]]; then
1083                 prefix="${default_nic}AND"
1084             fi
1085         fi
1086     fi
1087     set +x
1088     for tag in "${test_tag_array[@]}"; do
1089         if [[ "${tag}" == "!"* ]]; then
1090             # Exclude tags are not prefixed.
1091             TAGS+=("${tag}")
1092         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
1093             # Badly formed tag expressions can trigger way too much tests.
1094             set -x
1095             warn "The following tag expression hints at bad trigger: ${tag}"
1096             warn "Possible cause: Multiple triggers in a single comment."
1097             die "Aborting to avoid triggering too many tests."
1098         elif [[ "${tag}" == *"OR"* ]]; then
1099             # If OR had higher precedence than AND, it would be useful here.
1100             # Some people think it does, thus triggering way too much tests.
1101             set -x
1102             warn "The following tag expression hints at bad trigger: ${tag}"
1103             warn "Operator OR has lower precedence than AND. Use space instead."
1104             die "Aborting to avoid triggering too many tests."
1105         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
1106             # Empty and comment lines are skipped.
1107             # Other lines are normal tags, they are to be prefixed.
1108             TAGS+=("${prefix}${tag}")
1109         fi
1110     done
1111     set -x
1112 }
1113
1114
1115 function select_topology () {
1116
1117     # Variables read:
1118     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
1119     # - FLAVOR - Node flavor string, e.g. "clx" or "skx".
1120     # - CSIT_DIR - Path to existing root of local CSIT git repository.
1121     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
1122     # Variables set:
1123     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
1124     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
1125     # Functions called:
1126     # - die - Print to stderr and exit.
1127
1128     set -exuo pipefail
1129
1130     case_text="${NODENESS}_${FLAVOR}"
1131     case "${case_text}" in
1132         "1n_vbox")
1133             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1134             TOPOLOGIES_TAGS="2_node_single_link_topo"
1135             ;;
1136         "1n_skx" | "1n_tx2")
1137             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
1138             TOPOLOGIES_TAGS="2_node_single_link_topo"
1139             ;;
1140         "2n_skx")
1141             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
1142             TOPOLOGIES_TAGS="2_node_*_link_topo"
1143             ;;
1144         "2n_zn2")
1145             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1146             TOPOLOGIES_TAGS="2_node_*_link_topo"
1147             ;;
1148         "3n_skx")
1149             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1150             TOPOLOGIES_TAGS="3_node_*_link_topo"
1151             ;;
1152         "3n_icx")
1153             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_icx*.yaml )
1154             TOPOLOGIES_TAGS="3_node_*_link_topo"
1155             ;;
1156         "3na_spr")
1157             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3na_spr*.yaml )
1158             TOPOLOGIES_TAGS="3_node_*_link_topo"
1159             ;;
1160         "3nb_spr")
1161             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3nb_spr*.yaml )
1162             TOPOLOGIES_TAGS="3_node_*_link_topo"
1163             ;;
1164         "2n_clx")
1165             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1166             TOPOLOGIES_TAGS="2_node_*_link_topo"
1167             ;;
1168         "2n_icx")
1169             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_icx*.yaml )
1170             TOPOLOGIES_TAGS="2_node_*_link_topo"
1171             ;;
1172         "2n_spr")
1173             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_spr*.yaml )
1174             TOPOLOGIES_TAGS="2_node_*_link_topo"
1175             ;;
1176         "3n_snr")
1177             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_snr*.yaml )
1178             TOPOLOGIES_TAGS="3_node_single_link_topo"
1179             ;;
1180         "3n_tsh")
1181             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1182             TOPOLOGIES_TAGS="3_node_single_link_topo"
1183             ;;
1184         "2n_tx2")
1185             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_tx2*.yaml )
1186             TOPOLOGIES_TAGS="2_node_single_link_topo"
1187             ;;
1188         "3n_alt")
1189             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_alt*.yaml )
1190             TOPOLOGIES_TAGS="3_node_single_link_topo"
1191             ;;
1192         "1n_aws")
1193             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-aws*.yaml )
1194             TOPOLOGIES_TAGS="1_node_single_link_topo"
1195             ;;
1196         "2n_aws")
1197             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-aws*.yaml )
1198             TOPOLOGIES_TAGS="2_node_single_link_topo"
1199             ;;
1200         "3n_aws")
1201             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-aws*.yaml )
1202             TOPOLOGIES_TAGS="3_node_single_link_topo"
1203             ;;
1204         "1n_c6gn")
1205             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-c6gn*.yaml )
1206             TOPOLOGIES_TAGS="1_node_single_link_topo"
1207             ;;
1208         "2n_c6gn")
1209             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-c6gn*.yaml )
1210             TOPOLOGIES_TAGS="2_node_single_link_topo"
1211             ;;
1212         "3n_c6gn")
1213             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-c6gn*.yaml )
1214             TOPOLOGIES_TAGS="3_node_single_link_topo"
1215             ;;
1216         "1n_c6in")
1217             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*1n-c6in*.yaml )
1218             TOPOLOGIES_TAGS="1_node_single_link_topo"
1219             ;;
1220         "2n_c6in")
1221             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n-c6in*.yaml )
1222             TOPOLOGIES_TAGS="2_node_single_link_topo"
1223             ;;
1224         "3n_c6in")
1225             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n-c6in*.yaml )
1226             TOPOLOGIES_TAGS="3_node_single_link_topo"
1227             ;;
1228         *)
1229             # No falling back to default, that should have been done
1230             # by the function which has set NODENESS and FLAVOR.
1231             die "Unknown specification: ${case_text}"
1232     esac
1233
1234     if [[ -z "${TOPOLOGIES-}" ]]; then
1235         die "No applicable topology found!"
1236     fi
1237 }
1238
1239
1240 function set_environment_variables () {
1241
1242     # Depending on testbed topology, overwrite defaults set in the
1243     # resources/libraries/python/Constants.py file
1244     #
1245     # Variables read:
1246     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1247     # Variables set:
1248     # See specific cases
1249
1250     set -exuo pipefail
1251
1252     case "${TEST_CODE}" in
1253         *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1254             export TREX_RX_DESCRIPTORS_COUNT=1024
1255             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1256             export TREX_CORE_COUNT=6
1257             # Settings to prevent duration stretching.
1258             export PERF_TRIAL_STL_DELAY=0.1
1259             ;;
1260         *"1n-c6gn"* | *"2n-c6gn"* | *"3n-c6gn"*)
1261             export TREX_RX_DESCRIPTORS_COUNT=1024
1262             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1263             export TREX_CORE_COUNT=6
1264             # Settings to prevent duration stretching.
1265             export PERF_TRIAL_STL_DELAY=0.1
1266             ;;
1267         *"1n-c6in"* | *"2n-c6in"* | *"3n-c6in"*)
1268             export TREX_RX_DESCRIPTORS_COUNT=1024
1269             export TREX_EXTRA_CMDLINE="--mbuf-factor 19"
1270             export TREX_CORE_COUNT=6
1271             # Settings to prevent duration stretching.
1272             export PERF_TRIAL_STL_DELAY=0.1
1273             ;;
1274         *"2n-zn2"*)
1275             # Maciek's workaround for Zen2 with lower amount of cores.
1276             export TREX_CORE_COUNT=14
1277     esac
1278 }
1279
1280
1281 function untrap_and_unreserve_testbed () {
1282
1283     # Use this as a trap function to ensure testbed does not remain reserved.
1284     # Perhaps call directly before script exit, to free testbed for other jobs.
1285     # This function is smart enough to avoid multiple unreservations (so safe).
1286     # Topo cleanup is executed (call it best practice), ignoring failures.
1287     #
1288     # Hardcoded values:
1289     # - default message to die with if testbed might remain reserved.
1290     # Arguments:
1291     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1292     # Variables read (by inner function):
1293     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1294     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1295     # Variables set:
1296     # - TERRAFORM_MODULE_DIR - Terraform module directory.
1297     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1298     # Trap unregistered:
1299     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1300     # Functions called:
1301     # - die - Print to stderr and exit.
1302     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1303
1304     set -xo pipefail
1305     set +eu  # We do not want to exit early in a "teardown" function.
1306     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1307     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1308     if [[ -z "${wt-}" ]]; then
1309         set -eu
1310         warn "Testbed looks unreserved already. Trap removal failed before?"
1311     else
1312         ansible_playbook "cleanup" || true
1313         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1314             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1315         }
1316         case "${TEST_CODE}" in
1317             *"1n-aws"* | *"2n-aws"* | *"3n-aws"*)
1318                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}-c5n"
1319                 terraform_destroy || die "Failed to call terraform destroy."
1320                 ;;
1321             *"1n-c6gn"* | *"2n-c6gn"* | *"3n-c6gn"*)
1322                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}"
1323                 terraform_destroy || die "Failed to call terraform destroy."
1324                 ;;
1325             *"1n-c6in"* | *"2n-c6in"* | *"3n-c6in"*)
1326                 TERRAFORM_MODULE_DIR="terraform-aws-${NODENESS}-${FLAVOR}"
1327                 terraform_destroy || die "Failed to call terraform destroy."
1328                 ;;
1329             *)
1330                 ;;
1331         esac
1332         WORKING_TOPOLOGY=""
1333         set -eu
1334     fi
1335 }
1336
1337
1338 function warn () {
1339
1340     # Print the message to standard error.
1341     #
1342     # Arguments:
1343     # - ${@} - The text of the message.
1344
1345     set -exuo pipefail
1346
1347     echo "$@" >&2
1348 }